function love.load()
  love.graphics.setDefaultFilter('nearest', 'nearest')
  world = love.physics.newWorld(0, 500)
  skySprie = love.graphics.newImage('sprite/sky.png')
  
  math.randomseed(os.time())
  
  bird = {
    x = 40,
    y = 100,
    scale = 4,
    height = 13*4,
    width = 13*4,
    sprite = love.graphics.newImage('sprite/ugly_bird.png')
  }
  bird.body = love.physics.newBody( world, bird.x, bird.y+6, 'dynamic' )
  bird.shape = love.physics.newRectangleShape( bird.width, bird.height )
  bird.fixture = love.physics.newFixture( bird.body, bird.shape)
  pipe = {}
  
  dead = false
  timer = 0
  score = 0
end
best = 0

function love.update(dt)
  world:update(dt)
  updatePosition()
  if dead == false then
    timer = timer + dt
  end
  if timer > 2 then
    createPipes()
    timer = 0
  end
  
  for i, v in pairs (pipe) do
    v.x = v.x -2
    if v.x < -100 then
      table.remove (pipe, i)
    end
    if CheckCollision(bird.x-bird.width/2, (bird.y+6)-(bird.height+6)/2, bird.width, bird.height, v.x, v.y, v.height, v.width) then
      gameOver ()
      --error 'you lose'
    end
    if bird.x == v.x then score = score + 0.5 end
  end
  if score > best then best = score end
  if bird.y > love.graphics.getHeight() then
    gameOver()
    bird.body:setType( 'static' )
  end
  if bird.y < 0 then gameOver() end
end

function love.draw()
  local vx, vy = bird.body:getLinearVelocity()
  local rotation = (vy^1/3)*math.pi/360
  if rotation > 1.3 then rotation = 1.3 end
  
  love.graphics.draw(skySprie,0,0,nil,100)
  love.graphics.draw(bird.sprite, bird.x, bird.y,rotation , bird.scale, nil, 8, 8)
  
  love.graphics.setColor(15/255,99/255,35/255)
  for i, v in pairs (pipe) do
    love.graphics.rectangle('fill', v.x, v.y, v.height, v.width)
  end
  love.graphics.setColor(1,1,1)
  love.graphics.print('SCORE: '..score..'\n BEST:'..best, 0, 0, nil, 2, 2)
  --love.graphics.rectangle('line', bird.x-bird.width/2, (bird.y+6)-(bird.height+6)/2, bird.height, bird.width)
  if dead == true then
    local sh, sw = love.graphics.getHeight(), love.graphics.getWidth()
    love.graphics.print('GAME OVER', sw/3, sh/2, nil, 3, 3)
    
  end
end

function updatePosition()
  local x, y = bird.body:getPosition()
  bird.x = x
  bird.y = y
end

function love.touchpressed( id, x, y, dx, dy, pressure )
  if dead == false then
    bird.body:setLinearVelocity(0, -300)
  else love.load() end
end

function createPipes()
  local sh,sw =love.graphics.getHeight(), love.graphics.getWidth()
  local h1 = math.random(100, sh-250)
  table.insert(pipe,{x=sw,y=0,height=80,width=h1})
  table.insert(pipe,{x=sw,y=h1+150,height=80,width=sh-(h1+150)})
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function gameOver()
  dead = true
  bird.x, bird.y = -100, -100
  for k in pairs (pipe) do
    pipe [k] = nil
  end
end